MODULE_NAME='ClearoneConvergePro2MatrixMixer' (DEV dvPanel, DEV dvCrosspoints[])
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'
DEFINE_CONSTANT

MAX_XPOINTS = 30;

TL_FEEDBACK = 1;
LONG TL_FEEDBACK_TIMES[] = {300};

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE INTEGER nLevelValues[MAX_XPOINTS];

VOLATILE CHAR cActualLevelValues[MAX_XPOINTS][100];
VOLATILE CHAR cLastActualLevelValues[MAX_XPOINTS][100];

VOLATILE INTEGER nSelectedCrosspoint = 0;

VOLATILE INTEGER btnCrosspointSelection[] = 
{
	1,																// Crosspoint 1
	2,																// Crosspoint 2
	3,																// Crosspoint 3
	4,																// Crosspoint 4
	5,																// Crosspoint 5
	6,																// Crosspoint 6
	7,																// Crosspoint 7
	8,																// Crosspoint 8
	9,																// Crosspoint 9
	10,																// Crosspoint 10
	11,																// Crosspoint 11
	12,																// Crosspoint 12
	13,																// Crosspoint 13
	14,																// Crosspoint 14
	15,																// Crosspoint 15
	16,																// Crosspoint 16
	17,																// Crosspoint 17
	18,																// Crosspoint 18
	19,																// Crosspoint 19
	20,																// Crosspoint 20
	21,																// Crosspoint 21
	22,																// Crosspoint 22
	23,																// Crosspoint 23
	24,																// Crosspoint 24
	25,																// Crosspoint 25
	26,																// Crosspoint 26
	27,																// Crosspoint 27
	28,																// Crosspoint 28
	29,																// Crosspoint 29
	30																// Crosspoint 30
}

VOLATILE INTEGER btnCrosspointIndicators[] = 
{
	31,																// Crosspoint 1
	32,																// Crosspoint 2
	33,																// Crosspoint 3
	34,																// Crosspoint 4
	35,																// Crosspoint 5
	36,																// Crosspoint 6
	37,																// Crosspoint 7
	38,																// Crosspoint 8
	39,																// Crosspoint 9
	40,																// Crosspoint 10
	41,																// Crosspoint 11
	42,																// Crosspoint 12
	43,																// Crosspoint 13
	44,																// Crosspoint 14
	45,																// Crosspoint 15
	46,																// Crosspoint 16
	47,																// Crosspoint 17
	48,																// Crosspoint 18
	49,																// Crosspoint 19
	50,																// Crosspoint 20
	51,																// Crosspoint 21
	52,																// Crosspoint 22
	53,																// Crosspoint 23
	54,																// Crosspoint 24
	55,																// Crosspoint 25
	56,																// Crosspoint 26
	57,																// Crosspoint 27
	58,																// Crosspoint 28
	59,																// Crosspoint 29
	60																// Crosspoint 30
}


(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
DEFINE_FUNCTION ClearLastActualValues()
{
	STACK_VAR INTEGER nXPoint;
	
	FOR (nXPoint = 1; nXPoint <= MAX_LENGTH_ARRAY(cLastActualLevelValues); nXPoint++)
		cLastActualLevelValues[nXPoint] = '';
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

{
	STACK_VAR INTEGER nXPoint;
	
	FOR (nXPoint = 1; nXPoint <= MAX_LENGTH_ARRAY(dvCrosspoints); nXpoint++)
	{
		CREATE_LEVEL dvCrosspoints[nXPoint], AUDIOPROC_LVL, nLevelValues[nXPoint];
	}
}

TIMELINE_CREATE(TL_FEEDBACK, TL_FEEDBACK_TIMES, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT);

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT
////////////////////////////////////////////////////////////
// Actual Level Value
////////////////////////////////////////////////////////////
DATA_EVENT[dvCrosspoints]
{
	COMMAND:
	{
		STACK_VAR CHAR cHeader[DUET_MAX_HDR_LEN];
		
		STACK_VAR INTEGER nXPoint;
		
		nXPoint = GET_LAST(dvCrosspoints);
		
		cHeader = DuetParseCmdHeader(DATA.TEXT);
		
		SWITCH (cHeader)
		{
			CASE 'ACTUAL_LEVEL_VALUE':
			{
				cActualLevelValues[nXPoint] = DuetParseCmdParam(DATA.TEXT);
				BREAK;
			}
		}		
	}
}

DATA_EVENT[dvPanel]
{
	ONLINE:
	{
		ClearLastActualValues();
	}
}

////////////////////////////////////////////////////////////
// CROSSPOINT SELECTION
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, btnCrosspointSelection]
{
	PUSH:
	{
		STACK_VAR INTEGER nButton;
		
		nButton = GET_LAST(btnCrosspointSelection);
		
		IF (nButton <= MAX_LENGTH_ARRAY(dvCrosspoints))
		{
			nSelectedCrosspoint = nButton;
		}
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	STACK_VAR INTEGER nButton;
	
	FOR (nButton = 1; nButton <= MAX_LENGTH_ARRAY(dvCrosspoints); nButton++)
	{
		[dvPanel, btnCrosspointSelection[nButton]] = [dvCrosspoints[nButton], AUDIOPROC_STATE_FB];
		[dvPanel, btnCrosspointIndicators[nButton]] = (nSelectedCrosspoint == nButton);
		
		IF (cActualLevelValues[nButton] != cLastActualLevelValues[nButton])
		{
			cLastActualLevelValues[nButton] = cActualLevelValues[nButton];
			
			SEND_COMMAND dvPanel,"'^TXT-',ITOA(btnCrosspointSelection[nButton]),',0,',cActualLevelValues[nButton],'db'"
		}
	}
}

////////////////////////////////////////////////////////////
// CROSSPOINT CONTROL
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, 71]									// VOLIUME UP
{
	PUSH:
	{
		IF (nSelectedCrosspoint > 0)
		{
			TO[BUTTON.INPUT]
			TO[dvCrosspoints[nSelectedCrosspoint], AUDIOPROC_LEVEL_UP];
		}
	}
}

BUTTON_EVENT[dvPanel, 72]									// VOLIUME DOWN
{
	PUSH:
	{
		IF (nSelectedCrosspoint > 0)
		{
			TO[BUTTON.INPUT]
			TO[dvCrosspoints[nSelectedCrosspoint], AUDIOPROC_LEVEL_DN];
		}
	}
}

BUTTON_EVENT[dvPanel, 73]									// ROUTE
{
	PUSH:
	{
		IF (nSelectedCrosspoint > 0)
		{
			PULSE[dvCrosspoints[nSelectedCrosspoint], AUDIOPROC_STATE];
		}
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	IF (nSelectedCrosspoint > 0)
	{
		[dvPanel, 73] = [dvCrosspoints[nSelectedCrosspoint], AUDIOPROC_STATE_FB];
		
		SEND_LEVEL dvPanel, AUDIOPROC_LVL,  nLevelValues[nSelectedCrosspoint];
	}
}
(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)
